## ddnet 14.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

set(CMAKE_OSX_DEPLOYMENT_TARGET 10.9 CACHE INTERNAL "")
if(CMAKE_OSX_DEPLOYMENT_TARGET VERSION_LESS 10.9)
  message(WARNING "Building for macOS <= 10.9 is not supported")
endif()

file(STRINGS src/game/version.h VERSION_LINE
  LIMIT_COUNT 1
  REGEX "^#define GAME_RELEASE_VERSION "
)

if(VERSION_LINE MATCHES "\"([0-9]+)\\.([0-9]+)\\.([0-9]+)\"")
  set(VERSION_MAJOR ${CMAKE_MATCH_1})
  set(VERSION_MINOR ${CMAKE_MATCH_2})
  set(VERSION_PATCH ${CMAKE_MATCH_3})
elseif(VERSION_LINE MATCHES "\"([0-9]+)\\.([0-9]+)\"")
  set(VERSION_MAJOR ${CMAKE_MATCH_1})
  set(VERSION_MINOR ${CMAKE_MATCH_2})
  set(VERSION_PATCH "0")
else()
  message(FATAL_ERROR "Couldn't parse version from src/game/version.h")
endif()

if(POLICY CMP0017)
  cmake_policy(SET CMP0017 NEW)
endif()

if(POLICY CMP0048)
  cmake_policy(SET CMP0048 NEW)
  if(VERSION_PATCH STREQUAL "0")
    project(DDNet VERSION ${VERSION_MAJOR}.${VERSION_MINOR})
  else()
    project(DDNet VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
  endif()
else()
  project(DDNet)
  set(PROJECT_VERSION_MAJOR ${VERSION_MAJOR})
  set(PROJECT_VERSION_MINOR ${VERSION_MINOR})
  set(PROJECT_VERSION_PATCH ${VERSION_PATCH})
  if(VERSION_PATCH STREQUAL "0")
    set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR})
  else()
    set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
  endif()
endif()

set(ORIGINAL_CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH})
set(ORIGINAL_CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES})
set(ORIGINAL_CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
set(OWN_CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)
set(CMAKE_MODULE_PATH ${OWN_CMAKE_MODULE_PATH})

if(CMAKE_SIZEOF_VOID_P EQUAL 4)
  set(TARGET_BITS "32")
else()
  set(TARGET_BITS "64")
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Windows")
  set(TARGET_OS "windows")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Linux")
  set(TARGET_OS "linux")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
  set(TARGET_OS "mac")
endif()

include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(CheckSymbolExists)

check_symbol_exists(__i386 "" TARGET_ARCH_X86_i386)
if(TARGET_ARCH_X86_i386)
  set(TARGET_ARCH x86)
else()
  set(TARGET_ARCH)
endif()

set(AUTO_DEPENDENCIES_DEFAULT OFF)
set(AUTOUPDATE_DEFAULT OFF)
if(TARGET_OS STREQUAL "windows")
  set(AUTO_DEPENDENCIES_DEFAULT ON)
  set(AUTOUPDATE_DEFAULT ON)
elseif(TARGET_OS STREQUAL "linux")
  set(AUTOUPDATE_DEFAULT ON)
endif()

option(WEBSOCKETS "Enable websockets support" OFF)
option(MYSQL "Enable mysql support" OFF)
option(AUTOUPDATE "Enable the autoupdater" ${AUTOUPDATE_DEFAULT})
option(VIDEORECORDER "Enable video recording support via FFmpeg" OFF)
option(UPNP "Enable UPnP support" OFF)
option(ANTIBOT "Enable support for a dynamic anticheat library" OFF)
option(CLIENT "Compile client" ON)
option(DOWNLOAD_GTEST "Download and compile GTest" ${AUTO_DEPENDENCIES_DEFAULT})
option(PREFER_BUNDLED_LIBS "Prefer bundled libraries over system libraries" ${AUTO_DEPENDENCIES_DEFAULT})
option(DEV "Don't generate stuff necessary for packaging" OFF)

set(OpenGL_GL_PREFERENCE LEGACY)

# Set the default build type to Release
if(NOT(CMAKE_BUILD_TYPE))
  if(NOT(DEV))
    set(CMAKE_BUILD_TYPE Release)
  else()
    set(CMAKE_BUILD_TYPE Debug)
  endif()
endif()

if(NOT(CMAKE_BUILD_TYPE MATCHES "^(Release|Debug|RelWithDebInfo|MinSizeRel)$"))
  message(WARNING "Unknown CMAKE_BUILD_TYPE, should be one of Release, Debug, RelWithDebInfo or MinSizeRel")
endif()

set(DBG $<OR:$<CONFIG:Debug>,$<CONFIG:RelWithDebInfo>>)

set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS
  src/game/version.h
)

set(SERVER_EXECUTABLE DDNet-Server CACHE STRING "Name of the built server executable")
set(CLIENT_EXECUTABLE DDNet CACHE STRING "Name of the build client executable")

########################################################################
# Compiler flags
########################################################################

function(add_c_compiler_flag_if_supported VARIABLE FLAG)
  if(ARGC GREATER 2)
    set(CHECKED_FLAG "${ARGV2}")
  else()
    set(CHECKED_FLAG "${FLAG}")
  endif()
  string(REGEX REPLACE "[^A-Za-z0-9]" "_" CONFIG_VARIABLE "FLAG_SUPPORTED${CHECKED_FLAG}")
  check_c_compiler_flag("${CHECKED_FLAG}" ${CONFIG_VARIABLE})
  if(${CONFIG_VARIABLE})
    if(${VARIABLE})
      set("${VARIABLE}" "${${VARIABLE}};${FLAG}" PARENT_SCOPE)
    else()
      set("${VARIABLE}" "${FLAG}" PARENT_SCOPE)
    endif()
  endif()
endfunction()

# Force compiler colors on when using ninja. Ninja filters the colors out when
# it's not printing to a terminal on its own.
if(CMAKE_GENERATOR STREQUAL "Ninja")
  add_c_compiler_flag_if_supported(OUR_FLAGS -fdiagnostics-color=always)
  add_c_compiler_flag_if_supported(OUR_FLAGS -fcolor-diagnostics)
endif()

if(NOT MSVC)
  if(CMAKE_VERSION VERSION_LESS 3.1 OR TARGET_OS STREQUAL "mac")
    check_cxx_compiler_flag(-std=gnu++11 FLAG_SUPPORTED_std_gnu__11)
    if(FLAG_SUPPORTED_std_gnu__11)
      if(CMAKE_CXX_FLAGS)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
      else()
        set(CMAKE_CXX_FLAGS -std=gnu++11)
      endif()
    endif()
  endif()

  # Protect the stack pointer.
  # -fstack-protector-all doesn't work on MinGW.
  add_c_compiler_flag_if_supported(OUR_FLAGS -fstack-protector-all)

  # Inaccurate floating point numbers cause problems on mingw-w64-gcc when
  # compiling for x86, might cause problems elsewhere. So don't store floats
  # in registers but keep them at higher accuracy.

  if(TARGET_ARCH STREQUAL "x86")
    add_c_compiler_flag_if_supported(OUR_FLAGS -ffloat-store)
  endif()

  if(TARGET_OS STREQUAL "mac")
    add_c_compiler_flag_if_supported(OUR_FLAGS -stdlib=libc++)
  endif()

  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wall)
  if(CMAKE_VERSION VERSION_GREATER 3.3 OR CMAKE_VERSION VERSION_EQUAL 3.3)
    add_c_compiler_flag_if_supported(OUR_FLAGS_OWN
      $<$<COMPILE_LANGUAGE:C>:-Wdeclaration-after-statement>
      -Wdeclaration-after-statement
    )
  endif()
  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wextra)
  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wno-unused-parameter)
  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wno-missing-field-initializers)
  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wformat=2) # Warn about format strings.
  add_c_compiler_flag_if_supported(OUR_FLAGS_DEP -Wno-implicit-function-declaration)
  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wno-nullability-completeness) # Mac OS build on github
  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wduplicated-cond)
  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wduplicated-branches)
  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wlogical-op)
  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wrestrict)
  # TODO: Enable for C++ code except gtest
  #add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN "-Wuseless-cast")
endif()

if(NOT MSVC)
  check_c_compiler_flag("-O2;-Wp,-Werror;-D_FORTIFY_SOURCE=2" DEFINE_FORTIFY_SOURCE) # Some distributions define _FORTIFY_SOURCE by themselves.
endif()

########################################################################
# COMMON FUNCTIONS
########################################################################

function(set_glob VAR GLOBBING EXTS DIRECTORY) # ...
  set(GLOBS)
  foreach(ext ${EXTS})
    list(APPEND GLOBS "${DIRECTORY}/*.${ext}")
  endforeach()
  file(${GLOBBING} GLOB_RESULT ${GLOBS})
  list(SORT GLOB_RESULT)
  set(FILES)
  foreach(file ${ARGN})
    list(APPEND FILES "${PROJECT_SOURCE_DIR}/${DIRECTORY}/${file}")
  endforeach()

  if(NOT FILES STREQUAL GLOB_RESULT)
    message(AUTHOR_WARNING "${VAR} does not contain every file from directory ${DIRECTORY}")
    set(LIST_BUT_NOT_GLOB)
    if(POLICY CMP0057)
      cmake_policy(SET CMP0057 NEW)
      foreach(file ${FILES})
        if(NOT file IN_LIST GLOB_RESULT)
          list(APPEND LIST_BUT_NOT_GLOB ${file})
        endif()
      endforeach()
      if(LIST_BUT_NOT_GLOB)
        message(AUTHOR_WARNING "Entries only present in ${VAR}: ${LIST_BUT_NOT_GLOB}")
      endif()
      set(GLOB_BUT_NOT_LIST)
      foreach(file ${GLOB_RESULT})
        if(NOT file IN_LIST FILES)
          list(APPEND GLOB_BUT_NOT_LIST ${file})
        endif()
      endforeach()
      if(GLOB_BUT_NOT_LIST)
        message(AUTHOR_WARNING "Entries only present in ${DIRECTORY}: ${GLOB_BUT_NOT_LIST}")
      endif()
      if(NOT LIST_BUT_NOT_GLOB AND NOT GLOB_BUT_NOT_LIST)
        message(AUTHOR_WARNING "${VAR} is not alphabetically sorted")
      endif()
    endif()
  endif()

  set(${VAR} ${FILES} PARENT_SCOPE)
endfunction()

function(set_src VAR GLOBBING DIRECTORY) # ...
  set_glob(${VAR} ${GLOBBING} "c;cpp;h" ${DIRECTORY} ${ARGN})
  set(${VAR} ${${VAR}} PARENT_SCOPE)
endfunction()

########################################################################
# INITIALIZE TARGET LISTS
########################################################################

set(TARGETS_OWN)
set(TARGETS_DEP)

set(TARGETS_LINK) # Targets with a linking stage.

########################################################################
# DEPENDENCIES
########################################################################

function(set_extra_dirs_lib VARIABLE NAME)
  set("PATHS_${VARIABLE}_LIBDIR" PARENT_SCOPE)
  set("HINTS_${VARIABLE}_LIBDIR" PARENT_SCOPE)
  if(PREFER_BUNDLED_LIBS)
    set(TYPE HINTS)
  else()
    set(TYPE PATHS)
  endif()
  if(TARGET_BITS AND TARGET_OS)
    set(DIR "ddnet-libs/${NAME}/${TARGET_OS}/lib${TARGET_BITS}")
    set("${TYPE}_${VARIABLE}_LIBDIR" "${DIR}" PARENT_SCOPE)
    set("EXTRA_${VARIABLE}_LIBDIR" "${DIR}" PARENT_SCOPE)
  endif()
endfunction()

function(set_extra_dirs_include VARIABLE NAME LIBRARY)
  set("PATHS_${VARIABLE}_INCLUDEDIR" PARENT_SCOPE)
  set("HINTS_${VARIABLE}_INCLUDEDIR" PARENT_SCOPE)
  is_bundled(IS_BUNDLED "${LIBRARY}")
  if(IS_BUNDLED)
    set("HINTS_${VARIABLE}_INCLUDEDIR" "ddnet-libs/${NAME}/include" "ddnet-libs/${NAME}/include/${TARGET_OS}" PARENT_SCOPE)
  endif()
endfunction()

if(CMAKE_CROSSCOMPILING)
  set(CROSSCOMPILING_NO_CMAKE_SYSTEM_PATH NO_CMAKE_SYSTEM_PATH)
else()
  set(CROSSCOMPILING_NO_CMAKE_SYSTEM_PATH)
endif()

function(is_bundled VARIABLE PATH)
  if(PATH)
    string(FIND "${PATH}" "${PROJECT_SOURCE_DIR}" LOCAL_PATH_POS)
    if(LOCAL_PATH_POS EQUAL 0 AND TARGET_BITS AND TARGET_OS)
      set("${VARIABLE}" ON PARENT_SCOPE)
    else()
      set("${VARIABLE}" OFF PARENT_SCOPE)
    endif()
  else()
    set("${VARIABLE}" OFF PARENT_SCOPE)
  endif()
endfunction()

if(NOT CMAKE_CROSSCOMPILING)
  # Check for PkgConfig once so all the other `find_package` calls can do it
  # quietly.
  find_package(PkgConfig)
endif()
find_package(ZLIB)
find_package(Crypto)
find_package(Curl)
find_package(Freetype)
if(DOWNLOAD_GTEST)
  find_package(Git)
endif()
find_package(GLEW)
find_package(GTest)
if(MYSQL)
  find_package(MySQL)
else()
  set(MYSQL_LIBRARIES)
endif()
find_package(Ogg)
find_package(Opus)
find_package(Opusfile)
if(UPNP)
  find_package(Miniupnpc)
endif()
find_package(Pnglite)
find_package(PythonInterp 3)
find_package(SDL2)
if(VIDEORECORDER)
  find_package(FFMPEG)
endif()
find_package(Threads)
find_package(Wavpack)
if(WEBSOCKETS)
  find_package(Websockets)
else()
  set(WEBSOCKETS_LIBRARIES)
  set(WEBSOCKETS_INCLUDE_DIRS)
endif()


if(TARGET_OS AND TARGET_OS STREQUAL "mac")
  find_program(CMAKE_OTOOL otool)
  find_program(DMG dmg)
  find_program(HFSPLUS hfsplus)
  find_program(NEWFS_HFS newfs_hfs)
  if(DMG AND HFSPLUS AND NEWFS_HFS)
    set(DMGTOOLS_FOUND ON)
  else()
    set(DMGTOOLS_FOUND OFF)
  endif()

  find_program(HDIUTIL hdiutil)
  if(HDIUTIL)
    set(HDIUTIL_FOUND ON)
  else()
    set(HDIUTIL_FOUND OFF)
  endif()
endif()

message(STATUS "******** DDNet ********")
if(NOT TARGET_OS STREQUAL "mac")
  message(STATUS "Target OS: ${TARGET_OS} ${TARGET_BITS}bit")
else()
  message(STATUS "Target OS: ${TARGET_OS} ${TARGET_BITS}bit (SDK: ${CMAKE_OSX_SYSROOT})")
endif()
message(STATUS "Compiler: ${CMAKE_CXX_COMPILER}")

=== debian/changelog ===
ddnet (14.1-1ubuntu1) groovy; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Lower optimization level on s390x to fix a build failure
    - allow stderr because of s390x warnings

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 02 Jul 2020 15:04:07 +0200

ddnet (14.1-1) unstable; urgency=medium

  * New upstream release
  * Bump debhelper compat to 13

 -- Yangfl <mmyangfl@gmail.com>  Wed, 01 Jul 2020 12:29:20 +0800

ddnet (13.0.1-1ubuntu1) groovy; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Lower optimization level on s390x to fix a build failure
    - allow stderr because of s390x warnings

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 27 Apr 2020 15:38:40 +0200

ddnet (13.0.1-1) unstable; urgency=medium

  * New upstream release
  * Remove buggy websockets support
  * Add build dep libjsonparser-dev and add use-system-libjsonparser.patch

 -- Yangfl <mmyangfl@gmail.com>  Fri, 10 Apr 2020 10:32:55 +0800

=== debian/control ===
Source: ddnet
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Yangfl <mmyangfl@gmail.com>,
 SZ Lin (林上智) <szlin@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
Build-Depends-Arch:
 cmake,
 python3,
 libcurl4-openssl-dev,
 libfreetype6-dev,
 libogg-dev,
 libopus-dev,
 libopusfile-dev,
 libsdl2-dev,
 libmariadb-dev,
 libmysqlcppconn-dev,
 libboost-dev,
 libglew-dev,
 libpnglite-dev,
 libwavpack-dev,
 libjsonparser-dev,
 libgtest-dev,
 libnotify-dev,
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://ddnet.tw/
Vcs-Git: https://salsa.debian.org/games-team/ddnet.git
Vcs-Browser: https://salsa.debian.org/games-team/ddnet

Package: ddnet
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ddnet-data (>= ${source:Version}),
Description: Teeworlds modification with a unique cooperative gameplay
 DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
 modification with a unique cooperative gameplay. Help each other play through
 custom maps with up to 64 players, compete against the best in international
 tournaments, design your own maps, or run your own server.
 .
 This package contains the client binary for DDNet.

Package: ddnet-server
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ddnet-data (>= ${source:Version}),
Suggests:
 ddnet-tools,
Description: Server for DDNet
 DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
 modification with a unique cooperative gameplay. Help each other play through
 custom maps with up to 64 players, compete against the best in international
 tournaments, design your own maps, or run your own server.
 .
 This package contains the server binary for DDNet.

Package: ddnet-tools
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Tools for DDNet
 DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
 modification with a unique cooperative gameplay. Help each other play through
 custom maps with up to 64 players, compete against the best in international
 tournaments, design your own maps, or run your own server.
 .
 This package contains tools for DDNet maps and configs.

Package: ddnet-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 fonts-dejavu-core,
Recommends:
 fonts-wqy-microhei,
Description: Data for DDNet
 DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
 modification with a unique cooperative gameplay. Help each other play through
 custom maps with up to 64 players, compete against the best in international
 tournaments, design your own maps, or run your own server.
 .
 This package contains the static data for DDNet.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic -O3
export DEB_LDFLAGS_MAINT_APPEND =

include /usr/share/dpkg/architecture.mk

ifeq ($(DEB_HOST_ARCH),ia64)
  # gcc o3 segfault on ia64
  # It's just annoying, not a sign I'll care about ia64
  export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
endif

ifeq ($(DEB_HOST_ARCH),s390x)
  export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic -O1
endif

%:
	dh $@

build-indep:
	# pass

execute_after_dh_auto_clean-indep:
	$(RM) -r datasrc/*.pyc datasrc/__pycache__

override_dh_auto_configure-arch:
	dh_auto_configure -a -- \
		-DMYSQL=ON -DAUTOUPDATE=OFF \
		-DTESTRUNNER_ARGS=--gtest_filter=-Jobs.LookupHost

override_dh_auto_test-arch:
	+cd obj-$(DEB_BUILD_GNU_TYPE) && make run_tests

override_dh_auto_install-indep:
	for px in 16 32 48 128 256 512; do \
		size=$${px}x$${px}; \
		fn=other/icons/DDNet_$${size}x32.png; \
		if [ -f $${fn} ]; then \
			dir=debian/tmp/usr/share/icons/hicolor/$${size}/apps/; \
			mkdir -p $${dir}; \
			cp $${fn} $${dir}/ddnet.png; \
		fi; \
	done;

execute_after_dh_install-indep:
	for f in languages/license.txt; do \
		rm -r "debian/ddnet-data/usr/share/games/ddnet/data/$$f"; \
	done

## ddnet 15.1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -26,6 +26,10 @@
   cmake_policy(SET CMP0017 NEW)
 endif()
 
+if(POLICY CMP0042)
+  cmake_policy(SET CMP0042 NEW)
+endif()
+
 if(POLICY CMP0048)
   cmake_policy(SET CMP0048 NEW)
   if(VERSION_PATCH STREQUAL "0")
@@ -77,24 +81,24 @@
 endif()
 
 set(AUTO_DEPENDENCIES_DEFAULT OFF)
-set(AUTOUPDATE_DEFAULT OFF)
 if(TARGET_OS STREQUAL "windows")
   set(AUTO_DEPENDENCIES_DEFAULT ON)
-  set(AUTOUPDATE_DEFAULT ON)
 elseif(TARGET_OS STREQUAL "linux")
-  set(AUTOUPDATE_DEFAULT ON)
 endif()
 
 option(WEBSOCKETS "Enable websockets support" OFF)
 option(MYSQL "Enable mysql support" OFF)
-option(AUTOUPDATE "Enable the autoupdater" ${AUTOUPDATE_DEFAULT})
+option(AUTOUPDATE "Enable the autoupdater" OFF)
+option(INFORM_UPDATE "Inform about available updates" ON)
 option(VIDEORECORDER "Enable video recording support via FFmpeg" OFF)
 option(UPNP "Enable UPnP support" OFF)
 option(ANTIBOT "Enable support for a dynamic anticheat library" OFF)
 option(CLIENT "Compile client" ON)
 option(DOWNLOAD_GTEST "Download and compile GTest" ${AUTO_DEPENDENCIES_DEFAULT})
+option(STEAM "Build the Steam release version" OFF)
 option(PREFER_BUNDLED_LIBS "Prefer bundled libraries over system libraries" ${AUTO_DEPENDENCIES_DEFAULT})
 option(DEV "Don't generate stuff necessary for packaging" OFF)
+set(VERSION ${PROJECT_VERSION} CACHE STRING "Specify version string")
 
 set(OpenGL_GL_PREFERENCE LEGACY)
 
@@ -167,9 +171,13 @@
   # Inaccurate floating point numbers cause problems on mingw-w64-gcc when
   # compiling for x86, might cause problems elsewhere. So don't store floats
   # in registers but keep them at higher accuracy.
-
   if(TARGET_ARCH STREQUAL "x86")
     add_c_compiler_flag_if_supported(OUR_FLAGS -ffloat-store)
+  endif()
+
+  # Don't insert timestamps into PEs to keep the build reproducible.
+  if(TARGET_OS STREQUAL "windows")
+    add_c_compiler_flag_if_supported(OUR_FLAGS_LINK -Wl,--no-insert-timestamp)
   endif()
 
   if(TARGET_OS STREQUAL "mac")
@@ -253,6 +261,23 @@
   set(${VAR} ${${VAR}} PARENT_SCOPE)
 endfunction()
 
+function(set_own_rpath TARGET)
+  if(NOT TARGET_OS STREQUAL "windows" AND NOT TARGET_OS STREQUAL "mac")
+    if(CMAKE_VERSION VERSION_GREATER 3.14 OR CMAKE_VERSION VERSION_EQUAL 3.14)
+      set_property(TARGET ${TARGET} PROPERTY BUILD_RPATH_USE_ORIGIN TRUE)
+    elseif(CMAKE_VERSION VERSION_GREATER 3.8 OR CMAKE_VERSION VERSION_EQUAL 3.8)
+      set_property(TARGET ${TARGET} PROPERTY BUILD_RPATH "$ORIGIN")
+    endif()
+    set_property(TARGET ${TARGET} PROPERTY INSTALL_RPATH "$ORIGIN/../lib/ddnet")
+  endif()
+endfunction()
+
+if(NOT TARGET_OS STREQUAL "windows" AND NOT TARGET_OS STREQUAL "mac" AND CMAKE_VERSION VERSION_LESS 3.8)
+  if((CLIENT AND STEAM) OR ANTIBOT)
+    message(STATUS "Can't set BUILD_RPATH in CMake before 3.8, pass -Wl,-rpath,'$ORIGIN' manually if you wish to emulate this. Or just install a newer version of CMake...")
+  endif()
+endif()
+
 ########################################################################
 # INITIALIZE TARGET LISTS
 ########################################################################
@@ -317,62 +342,7 @@
 find_package(ZLIB)
 find_package(Crypto)
 find_package(Curl)
-find_package(Freetype)
-if(DOWNLOAD_GTEST)
-  find_package(Git)
-endif()
-find_package(GLEW)
-find_package(GTest)
-if(MYSQL)
-  find_package(MySQL)
-else()
-  set(MYSQL_LIBRARIES)
-endif()
-find_package(Ogg)
-find_package(Opus)
-find_package(Opusfile)
-if(UPNP)
-  find_package(Miniupnpc)
-endif()
-find_package(Pnglite)
-find_package(PythonInterp 3)
-find_package(SDL2)
 if(VIDEORECORDER)
   find_package(FFMPEG)
 endif()
-find_package(Threads)
-find_package(Wavpack)
-if(WEBSOCKETS)
-  find_package(Websockets)
-else()
-  set(WEBSOCKETS_LIBRARIES)
-  set(WEBSOCKETS_INCLUDE_DIRS)
-endif()
-
-
-if(TARGET_OS AND TARGET_OS STREQUAL "mac")
-  find_program(CMAKE_OTOOL otool)
-  find_program(DMG dmg)
-  find_program(HFSPLUS hfsplus)
-  find_program(NEWFS_HFS newfs_hfs)
-  if(DMG AND HFSPLUS AND NEWFS_HFS)
-    set(DMGTOOLS_FOUND ON)
-  else()
-    set(DMGTOOLS_FOUND OFF)
-  endif()
-
-  find_program(HDIUTIL hdiutil)
-  if(HDIUTIL)
-    set(HDIUTIL_FOUND ON)
-  else()
-    set(HDIUTIL_FOUND OFF)
-  endif()
-endif()
-
-message(STATUS "******** DDNet ********")
-if(NOT TARGET_OS STREQUAL "mac")
-  message(STATUS "Target OS: ${TARGET_OS} ${TARGET_BITS}bit")
-else()
-  message(STATUS "Target OS: ${TARGET_OS} ${TARGET_BITS}bit (SDK: ${CMAKE_OSX_SYSROOT})")
-endif()
-message(STATUS "Compiler: ${CMAKE_CXX_COMPILER}")
+find_package(Freetype)

=== debian/changelog ===
ddnet (15.1.3-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Sat, 17 Oct 2020 14:28:41 +0000

=== debian/control ===
--- 
+++ 
@@ -25,6 +25,7 @@
  libjsonparser-dev,
  libgtest-dev,
  libnotify-dev,
+ libsqlite3-dev,
 Rules-Requires-Root: no
 Standards-Version: 4.5.0
 Homepage: https://ddnet.tw/
@@ -81,7 +82,7 @@
  ${misc:Depends},
  fonts-dejavu-core,
 Recommends:
- fonts-wqy-microhei,
+ fonts-noto-cjk,
 Description: Data for DDNet
  DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
  modification with a unique cooperative gameplay. Help each other play through

=== debian/rules ===
--- 
+++ 
@@ -15,9 +15,6 @@
   export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
 endif
 
-ifeq ($(DEB_HOST_ARCH),s390x)
-  export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic -O1
-endif
 
 %:
 	dh $@
@@ -26,7 +23,7 @@
 	# pass
 
 execute_after_dh_auto_clean-indep:
-	$(RM) -r datasrc/*.pyc datasrc/__pycache__
+	$(RM) -r datasrc/__pycache__ datasrc/seven/__pycache__
 
 override_dh_auto_configure-arch:
 	dh_auto_configure -a -- \
@@ -48,6 +45,6 @@
 	done;
 
 execute_after_dh_install-indep:
-	for f in languages/license.txt; do \
-		rm -r "debian/ddnet-data/usr/share/games/ddnet/data/$$f"; \
+	for f in languages/license.txt maps/license.txt skins/license.txt; do \
+		$(RM) "debian/ddnet-data/usr/share/games/ddnet/data/$$f"; \
 	done

## ddnet 15.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,7 @@
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 2.8.12...3.19.1)
+if(CMAKE_VERSION VERSION_LESS 3.12)
+  cmake_policy(VERSION ${CMAKE_VERSION})
+endif()
 
 set(CMAKE_OSX_DEPLOYMENT_TARGET 10.9 CACHE INTERNAL "")
 if(CMAKE_OSX_DEPLOYMENT_TARGET VERSION_LESS 10.9)
@@ -22,23 +25,8 @@
   message(FATAL_ERROR "Couldn't parse version from src/game/version.h")
 endif()
 
-if(POLICY CMP0017)
-  cmake_policy(SET CMP0017 NEW)
-endif()
-
-if(POLICY CMP0042)
-  cmake_policy(SET CMP0042 NEW)
-endif()
-
-if(POLICY CMP0048)
-  cmake_policy(SET CMP0048 NEW)
-  if(VERSION_PATCH STREQUAL "0")
-    project(DDNet VERSION ${VERSION_MAJOR}.${VERSION_MINOR})
-  else()
-    project(DDNet VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
-  endif()
-else()
-  project(DDNet)
+# Extra support for CMake pre-3.0
+if(NOT POLICY CMP0048)
   set(PROJECT_VERSION_MAJOR ${VERSION_MAJOR})
   set(PROJECT_VERSION_MINOR ${VERSION_MINOR})
   set(PROJECT_VERSION_PATCH ${VERSION_PATCH})
@@ -47,6 +35,11 @@
   else()
     set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
   endif()
+endif()
+if(VERSION_PATCH STREQUAL "0")
+  project(DDNet VERSION ${VERSION_MAJOR}.${VERSION_MINOR})
+else()
+  project(DDNet VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 endif()
 
 set(ORIGINAL_CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH})
@@ -96,9 +89,15 @@
 option(CLIENT "Compile client" ON)
 option(DOWNLOAD_GTEST "Download and compile GTest" ${AUTO_DEPENDENCIES_DEFAULT})
 option(STEAM "Build the Steam release version" OFF)
+option(DISCORD "Enable Discord rich presence support" OFF)
+option(DISCORD_DYNAMIC "Enable discovering Discord rich presence libraries at runtime (Linux only)" OFF)
 option(PREFER_BUNDLED_LIBS "Prefer bundled libraries over system libraries" ${AUTO_DEPENDENCIES_DEFAULT})
 option(DEV "Don't generate stuff necessary for packaging" OFF)
-set(VERSION ${PROJECT_VERSION} CACHE STRING "Specify version string")
+
+# Set version if not explicitly set
+if(NOT VERSION)
+  set(VERSION ${PROJECT_VERSION})
+endif()
 
 set(OpenGL_GL_PREFERENCE LEGACY)
 
@@ -117,9 +116,13 @@
 
 set(DBG $<OR:$<CONFIG:Debug>,$<CONFIG:RelWithDebInfo>>)
 
-set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS
-  src/game/version.h
-)
+if(CMAKE_VERSION VERSION_LESS 3.0)
+  configure_file(src/game/version.h vd.h)
+else()
+  set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS
+    src/game/version.h
+  )
+endif()
 
 set(SERVER_EXECUTABLE DDNet-Server CACHE STRING "Name of the built server executable")
 set(CLIENT_EXECUTABLE DDNet CACHE STRING "Name of the build client executable")
@@ -201,6 +204,7 @@
   add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wduplicated-branches)
   add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wlogical-op)
   add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wrestrict)
+  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wthread-safety)
   # TODO: Enable for C++ code except gtest
   #add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN "-Wuseless-cast")
 endif()
@@ -263,9 +267,7 @@
 
 function(set_own_rpath TARGET)
   if(NOT TARGET_OS STREQUAL "windows" AND NOT TARGET_OS STREQUAL "mac")
-    if(CMAKE_VERSION VERSION_GREATER 3.14 OR CMAKE_VERSION VERSION_EQUAL 3.14)
-      set_property(TARGET ${TARGET} PROPERTY BUILD_RPATH_USE_ORIGIN TRUE)
-    elseif(CMAKE_VERSION VERSION_GREATER 3.8 OR CMAKE_VERSION VERSION_EQUAL 3.8)
+    if(CMAKE_VERSION VERSION_GREATER 3.8 OR CMAKE_VERSION VERSION_EQUAL 3.8)
       set_property(TARGET ${TARGET} PROPERTY BUILD_RPATH "$ORIGIN")
     endif()
     set_property(TARGET ${TARGET} PROPERTY INSTALL_RPATH "$ORIGIN/../lib/ddnet")
@@ -273,7 +275,7 @@
 endfunction()
 
 if(NOT TARGET_OS STREQUAL "windows" AND NOT TARGET_OS STREQUAL "mac" AND CMAKE_VERSION VERSION_LESS 3.8)
-  if((CLIENT AND STEAM) OR ANTIBOT)
+  if((CLIENT AND (STEAM OR DISCORD_DYNAMIC)) OR ANTIBOT)
     message(STATUS "Can't set BUILD_RPATH in CMake before 3.8, pass -Wl,-rpath,'$ORIGIN' manually if you wish to emulate this. Or just install a newer version of CMake...")
   endif()
 endif()
@@ -337,12 +339,3 @@
 if(NOT CMAKE_CROSSCOMPILING)
   # Check for PkgConfig once so all the other `find_package` calls can do it
   # quietly.
-  find_package(PkgConfig)
-endif()
-find_package(ZLIB)
-find_package(Crypto)
-find_package(Curl)
-if(VIDEORECORDER)
-  find_package(FFMPEG)
-endif()
-find_package(Freetype)

=== debian/changelog ===
ddnet (15.3.2-1ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Lower optimization level on s390x to fix a build failure
    - allow stderr because of s390x warnings

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 28 Feb 2021 09:30:45 +0100

ddnet (15.3.2-1) unstable; urgency=medium

  * New upstream release
    + Fix FTBFS on riscv64 (Closes: #978632)
  * Bump Standards-Version to 4.5.1

 -- Yangfl <mmyangfl@gmail.com>  Sun, 21 Feb 2021 22:46:10 +0800

ddnet (15.1.3-1ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Lower optimization level on s390x to fix a build failure
    - allow stderr because of s390x warnings

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 29 Oct 2020 08:46:01 +0100

=== debian/rules ===
--- 
+++ 
@@ -15,6 +15,9 @@
   export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
 endif
 
+ifeq ($(DEB_HOST_ARCH),s390x)
+  export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic -O1
+endif
 
 %:
 	dh $@
@@ -45,6 +48,6 @@
 	done;
 
 execute_after_dh_install-indep:
-	for f in languages/license.txt maps/license.txt skins/license.txt; do \
+	for f in assets/entities/license.txt languages/license.txt maps/license.txt skins/license.txt; do \
 		$(RM) "debian/ddnet-data/usr/share/games/ddnet/data/$$f"; \
 	done

## ddnet 15.5.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -60,6 +60,8 @@
   set(TARGET_OS "linux")
 elseif(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
   set(TARGET_OS "mac")
+elseif(CMAKE_SYSTEM_NAME STREQUAL "Haiku")
+  set(TARGET_OS "haiku")
 endif()
 
 include(CheckCCompilerFlag)
@@ -155,7 +157,7 @@
   add_c_compiler_flag_if_supported(OUR_FLAGS -fcolor-diagnostics)
 endif()
 
-if(NOT MSVC)
+if(NOT MSVC AND NOT HAIKU)
   if(CMAKE_VERSION VERSION_LESS 3.1 OR TARGET_OS STREQUAL "mac")
     check_cxx_compiler_flag(-std=gnu++11 FLAG_SUPPORTED_std_gnu__11)
     if(FLAG_SUPPORTED_std_gnu__11)
@@ -170,6 +172,9 @@
   # Protect the stack pointer.
   # -fstack-protector-all doesn't work on MinGW.
   add_c_compiler_flag_if_supported(OUR_FLAGS -fstack-protector-all)
+
+  # Disable exceptions as DDNet does not use them.
+  add_c_compiler_flag_if_supported(OUR_FLAGS -fno-exceptions)
 
   # Inaccurate floating point numbers cause problems on mingw-w64-gcc when
   # compiling for x86, might cause problems elsewhere. So don't store floats
@@ -209,7 +214,7 @@
   #add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN "-Wuseless-cast")
 endif()
 
-if(NOT MSVC)
+if(NOT MSVC AND NOT HAIKU)
   check_c_compiler_flag("-O2;-Wp,-Werror;-D_FORTIFY_SOURCE=2" DEFINE_FORTIFY_SOURCE) # Some distributions define _FORTIFY_SOURCE by themselves.
 endif()
 
@@ -330,12 +335,3 @@
       set("${VARIABLE}" ON PARENT_SCOPE)
     else()
       set("${VARIABLE}" OFF PARENT_SCOPE)
-    endif()
-  else()
-    set("${VARIABLE}" OFF PARENT_SCOPE)
-  endif()
-endfunction()
-
-if(NOT CMAKE_CROSSCOMPILING)
-  # Check for PkgConfig once so all the other `find_package` calls can do it
-  # quietly.

=== debian/changelog ===
ddnet (15.5.4-1ubuntu1) impish; urgency=medium

  * Allow stderr to make warnings not fatal in autopkgtests on armhf and
    ppc64el (see: #995742)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 05 Oct 2021 17:55:37 +0200

ddnet (15.5.4-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.6.0

 -- Yangfl <mmyangfl@gmail.com>  Thu, 30 Sep 2021 11:45:10 +0800

=== debian/control ===
--- 
+++ 
@@ -27,7 +27,7 @@
  libnotify-dev,
  libsqlite3-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: https://ddnet.tw/
 Vcs-Git: https://salsa.debian.org/games-team/ddnet.git
 Vcs-Browser: https://salsa.debian.org/games-team/ddnet

## ddnet 15.9.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 set(CMAKE_OSX_DEPLOYMENT_TARGET 10.9 CACHE INTERNAL "")
 if(CMAKE_OSX_DEPLOYMENT_TARGET VERSION_LESS 10.9)
-  message(WARNING "Building for macOS <= 10.9 is not supported")
+  message(WARNING "Building for macOS < 10.9 is not supported")
 endif()
 
 file(STRINGS src/game/version.h VERSION_LINE
@@ -54,6 +54,20 @@
   set(TARGET_BITS "64")
 endif()
 
+if("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "arm" OR "${CMAKE_SYSTEM_PROCESSOR}" MATCHES "aarch64")
+  if(TARGET_BITS STREQUAL "32")
+    set(TARGET_CPU_ARCHITECTURE "arm")
+  else()
+    set(TARGET_CPU_ARCHITECTURE "arm64")
+  endif()
+else()
+  if(TARGET_BITS STREQUAL "32")
+    set(TARGET_CPU_ARCHITECTURE "x86")
+  else()
+    set(TARGET_CPU_ARCHITECTURE "x86_64")
+  endif()
+endif()
+
 if(CMAKE_SYSTEM_NAME STREQUAL "Windows")
   set(TARGET_OS "windows")
 elseif(CMAKE_SYSTEM_NAME STREQUAL "Linux")
@@ -62,11 +76,14 @@
   set(TARGET_OS "mac")
 elseif(CMAKE_SYSTEM_NAME STREQUAL "Haiku")
   set(TARGET_OS "haiku")
+elseif(CMAKE_SYSTEM_NAME STREQUAL "Android")
+  set(TARGET_OS "android")
 endif()
 
 include(CheckCCompilerFlag)
 include(CheckCXXCompilerFlag)
 include(CheckSymbolExists)
+include(CheckAtomic)
 
 check_symbol_exists(__i386 "" TARGET_ARCH_X86_i386)
 if(TARGET_ARCH_X86_i386)
@@ -83,18 +100,26 @@
 
 option(WEBSOCKETS "Enable websockets support" OFF)
 option(MYSQL "Enable mysql support" OFF)
+option(TEST_MYSQL "Test mysql support in unit tests (also sets -DMYSQL=ON)" OFF)
 option(AUTOUPDATE "Enable the autoupdater" OFF)
 option(INFORM_UPDATE "Inform about available updates" ON)
 option(VIDEORECORDER "Enable video recording support via FFmpeg" OFF)
 option(UPNP "Enable UPnP support" OFF)
 option(ANTIBOT "Enable support for a dynamic anticheat library" OFF)
+option(HEADLESS_CLIENT "Build the client without graphics" OFF)
 option(CLIENT "Compile client" ON)
+option(SERVER "Compile server" ON)
+option(TOOLS "Compile tools" ON)
 option(DOWNLOAD_GTEST "Download and compile GTest" ${AUTO_DEPENDENCIES_DEFAULT})
 option(STEAM "Build the Steam release version" OFF)
 option(DISCORD "Enable Discord rich presence support" OFF)
 option(DISCORD_DYNAMIC "Enable discovering Discord rich presence libraries at runtime (Linux only)" OFF)
 option(PREFER_BUNDLED_LIBS "Prefer bundled libraries over system libraries" ${AUTO_DEPENDENCIES_DEFAULT})
 option(DEV "Don't generate stuff necessary for packaging" OFF)
+
+if(TEST_MYSQL)
+  set(MYSQL ON)
+endif()
 
 # Set version if not explicitly set
 if(NOT VERSION)
@@ -268,7 +293,9 @@
 function(set_src VAR GLOBBING DIRECTORY) # ...
   set_glob(${VAR} ${GLOBBING} "c;cpp;h" ${DIRECTORY} ${ARGN})
   set(${VAR} ${${VAR}} PARENT_SCOPE)
+  set(CHECKSUM_SRC ${CHECKSUM_SRC} ${${VAR}} PARENT_SCOPE)
 endfunction()
+set(CHECKSUM_SRC)
 
 function(set_own_rpath TARGET)
   if(NOT TARGET_OS STREQUAL "windows" AND NOT TARGET_OS STREQUAL "mac")
@@ -298,40 +325,17 @@
 # DEPENDENCIES
 ########################################################################
 
-function(set_extra_dirs_lib VARIABLE NAME)
-  set("PATHS_${VARIABLE}_LIBDIR" PARENT_SCOPE)
-  set("HINTS_${VARIABLE}_LIBDIR" PARENT_SCOPE)
-  if(PREFER_BUNDLED_LIBS)
-    set(TYPE HINTS)
-  else()
-    set(TYPE PATHS)
-  endif()
-  if(TARGET_BITS AND TARGET_OS)
-    set(DIR "ddnet-libs/${NAME}/${TARGET_OS}/lib${TARGET_BITS}")
-    set("${TYPE}_${VARIABLE}_LIBDIR" "${DIR}" PARENT_SCOPE)
-    set("EXTRA_${VARIABLE}_LIBDIR" "${DIR}" PARENT_SCOPE)
-  endif()
-endfunction()
-
-function(set_extra_dirs_include VARIABLE NAME LIBRARY)
-  set("PATHS_${VARIABLE}_INCLUDEDIR" PARENT_SCOPE)
-  set("HINTS_${VARIABLE}_INCLUDEDIR" PARENT_SCOPE)
-  is_bundled(IS_BUNDLED "${LIBRARY}")
-  if(IS_BUNDLED)
-    set("HINTS_${VARIABLE}_INCLUDEDIR" "ddnet-libs/${NAME}/include" "ddnet-libs/${NAME}/include/${TARGET_OS}" PARENT_SCOPE)
-  endif()
-endfunction()
-
-if(CMAKE_CROSSCOMPILING)
-  set(CROSSCOMPILING_NO_CMAKE_SYSTEM_PATH NO_CMAKE_SYSTEM_PATH)
-else()
-  set(CROSSCOMPILING_NO_CMAKE_SYSTEM_PATH)
-endif()
-
-function(is_bundled VARIABLE PATH)
-  if(PATH)
-    string(FIND "${PATH}" "${PROJECT_SOURCE_DIR}" LOCAL_PATH_POS)
-    if(LOCAL_PATH_POS EQUAL 0 AND TARGET_BITS AND TARGET_OS)
-      set("${VARIABLE}" ON PARENT_SCOPE)
-    else()
-      set("${VARIABLE}" OFF PARENT_SCOPE)
+if((CMAKE_OSX_ARCHITECTURES STREQUAL "arm64;x86_64" OR CMAKE_OSX_ARCHITECTURES STREQUAL "x86_64;arm64") AND TARGET_OS STREQUAL "mac")
+  set(FAT ON)
+else()
+  set(FAT OFF)
+endif()
+
+if(FAT)
+  set(LIB_DIR "${TARGET_OS}/libfat")
+elseif(TARGET_CPU_ARCHITECTURE STREQUAL "arm" OR TARGET_CPU_ARCHITECTURE STREQUAL "arm64")
+  set(LIB_DIR "${TARGET_OS}/lib${TARGET_CPU_ARCHITECTURE}")
+else()
+  set(LIB_DIR "${TARGET_OS}/lib${TARGET_BITS}")
+endif()
+

=== debian/changelog ===
ddnet (15.9.1-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Tue, 22 Feb 2022 22:04:09 +0800

ddnet (15.8.1-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Sat, 01 Jan 2022 14:31:29 +0800

ddnet (15.7-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Mon, 29 Nov 2021 06:47:41 +0800

ddnet (15.6.2-1) unstable; urgency=medium

  * New upstream release
  * Allow stderr in autopkgtest for gcc warnings (Closes: #995742)

 -- Yangfl <mmyangfl@gmail.com>  Sun, 14 Nov 2021 03:59:51 +0800

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  debhelper-compat (= 13),
 Build-Depends-Arch:
  cmake,
- python3,
+ python3:native,
  libcurl4-openssl-dev,
  libfreetype6-dev,
  libogg-dev,
@@ -23,7 +23,8 @@
  libpnglite-dev,
  libwavpack-dev,
  libjsonparser-dev,
- libgtest-dev,
+ libgtest-dev <!nocheck>,
+ libgmock-dev <!nocheck>,
  libnotify-dev,
  libsqlite3-dev,
 Rules-Requires-Root: no

=== debian/rules ===
--- 
+++ 
@@ -15,9 +15,6 @@
   export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
 endif
 
-ifeq ($(DEB_HOST_ARCH),s390x)
-  export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic -O1
-endif
 
 %:
 	dh $@

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.xz%ddnet-$1.tar.xz%" \
   https://ddnet.tw/downloads/ \
   DDNet-(\d[\d.]*)\.tar\.xz debian uupdate

## ddnet 16.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -93,9 +93,14 @@
 endif()
 
 set(AUTO_DEPENDENCIES_DEFAULT OFF)
+set(AUTO_VULKAN_BACKEND ON)
 if(TARGET_OS STREQUAL "windows")
   set(AUTO_DEPENDENCIES_DEFAULT ON)
-elseif(TARGET_OS STREQUAL "linux")
+  if(TARGET_CPU_ARCHITECTURE STREQUAL "x86")
+    set(AUTO_VULKAN_BACKEND OFF)
+  endif()
+elseif(TARGET_OS STREQUAL "mac")
+  set(AUTO_VULKAN_BACKEND OFF)
 endif()
 
 option(WEBSOCKETS "Enable websockets support" OFF)
@@ -103,7 +108,7 @@
 option(TEST_MYSQL "Test mysql support in unit tests (also sets -DMYSQL=ON)" OFF)
 option(AUTOUPDATE "Enable the autoupdater" OFF)
 option(INFORM_UPDATE "Inform about available updates" ON)
-option(VIDEORECORDER "Enable video recording support via FFmpeg" OFF)
+option(VIDEORECORDER "Enable video recording support via FFmpeg" ON)
 option(UPNP "Enable UPnP support" OFF)
 option(ANTIBOT "Enable support for a dynamic anticheat library" OFF)
 option(HEADLESS_CLIENT "Build the client without graphics" OFF)
@@ -116,6 +121,9 @@
 option(DISCORD_DYNAMIC "Enable discovering Discord rich presence libraries at runtime (Linux only)" OFF)
 option(PREFER_BUNDLED_LIBS "Prefer bundled libraries over system libraries" ${AUTO_DEPENDENCIES_DEFAULT})
 option(DEV "Don't generate stuff necessary for packaging" OFF)
+option(VULKAN "Enable the vulkan backend" ${AUTO_VULKAN_BACKEND})
+
+option(EXCEPTION_HANDLING "Enable exception handling (only works with Windows as of now)" OFF)
 
 if(TEST_MYSQL)
   set(MYSQL ON)
@@ -184,12 +192,12 @@
 
 if(NOT MSVC AND NOT HAIKU)
   if(CMAKE_VERSION VERSION_LESS 3.1 OR TARGET_OS STREQUAL "mac")
-    check_cxx_compiler_flag(-std=gnu++11 FLAG_SUPPORTED_std_gnu__11)
-    if(FLAG_SUPPORTED_std_gnu__11)
+    check_cxx_compiler_flag(-std=gnu++17 FLAG_SUPPORTED_std_gnu__17)
+    if(FLAG_SUPPORTED_std_gnu__17)
       if(CMAKE_CXX_FLAGS)
-        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++17")
       else()
-        set(CMAKE_CXX_FLAGS -std=gnu++11)
+        set(CMAKE_CXX_FLAGS -std=gnu++17)
       endif()
     endif()
   endif()
@@ -215,6 +223,14 @@
 
   if(TARGET_OS STREQUAL "mac")
     add_c_compiler_flag_if_supported(OUR_FLAGS -stdlib=libc++)
+  endif()
+
+  if(EXCEPTION_HANDLING)
+    add_c_compiler_flag_if_supported(OUR_FLAGS -DCONF_EXCEPTION_HANDLING)
+    # use the frame pointer (frame pointer usage is disabled by default in
+    # some architectures like x86_64 and for some optimization levels; and it
+    # may be impossible to walk the call stack without it)
+    add_c_compiler_flag_if_supported(OUR_FLAGS -fno-omit-frame-pointer)
   endif()
 
   add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wall)
@@ -234,9 +250,17 @@
   add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wduplicated-branches)
   add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wlogical-op)
   add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wrestrict)
+  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wshadow=local) # global has too many occurences
   add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wthread-safety)
-  # TODO: Enable for C++ code except gtest
-  #add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN "-Wuseless-cast")
+  # add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wdouble-promotion) # Many occurences
+  # add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wnull-dereference) # Many occurences
+  # add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wuseless-cast) # TODO: Enable for C++ code except gtest
+endif()
+
+if(MSVC)
+  if(EXCEPTION_HANDLING)
+  add_c_compiler_flag_if_supported(OUR_FLAGS /DCONF_EXCEPTION_HANDLING)
+  endif()
 endif()
 
 if(NOT MSVC AND NOT HAIKU)
@@ -307,35 +331,3 @@
 endfunction()
 
 if(NOT TARGET_OS STREQUAL "windows" AND NOT TARGET_OS STREQUAL "mac" AND CMAKE_VERSION VERSION_LESS 3.8)
-  if((CLIENT AND (STEAM OR DISCORD_DYNAMIC)) OR ANTIBOT)
-    message(STATUS "Can't set BUILD_RPATH in CMake before 3.8, pass -Wl,-rpath,'$ORIGIN' manually if you wish to emulate this. Or just install a newer version of CMake...")
-  endif()
-endif()
-
-########################################################################
-# INITIALIZE TARGET LISTS
-########################################################################
-
-set(TARGETS_OWN)
-set(TARGETS_DEP)
-
-set(TARGETS_LINK) # Targets with a linking stage.
-
-########################################################################
-# DEPENDENCIES
-########################################################################
-
-if((CMAKE_OSX_ARCHITECTURES STREQUAL "arm64;x86_64" OR CMAKE_OSX_ARCHITECTURES STREQUAL "x86_64;arm64") AND TARGET_OS STREQUAL "mac")
-  set(FAT ON)
-else()
-  set(FAT OFF)
-endif()
-
-if(FAT)
-  set(LIB_DIR "${TARGET_OS}/libfat")
-elseif(TARGET_CPU_ARCHITECTURE STREQUAL "arm" OR TARGET_CPU_ARCHITECTURE STREQUAL "arm64")
-  set(LIB_DIR "${TARGET_OS}/lib${TARGET_CPU_ARCHITECTURE}")
-else()
-  set(LIB_DIR "${TARGET_OS}/lib${TARGET_BITS}")
-endif()
-

=== debian/changelog ===
ddnet (16.0.2-1build1) kinetic; urgency=medium

  * No-change rebuild against libavcodec59

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 19 Jul 2022 12:46:14 +0000

ddnet (16.0.2-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Sun, 03 Apr 2022 14:30:49 +0800

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: ddnet
 Section: games
 Priority: optional
-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
  Yangfl <mmyangfl@gmail.com>,
  SZ Lin (林上智) <szlin@debian.org>,
@@ -27,6 +28,12 @@
  libgmock-dev <!nocheck>,
  libnotify-dev,
  libsqlite3-dev,
+ libvulkan-dev,
+ glslang-tools,
+ libx264-dev,
+ libavformat-dev,
+ libswresample-dev,
+ libswscale-dev,
 Rules-Requires-Root: no
 Standards-Version: 4.6.0
 Homepage: https://ddnet.tw/
